dnl Copyright (C) 1998 Eleftherios Gkioulekas <lf@amath.washington.edu>
dnl  
dnl This program is free software; you can redistribute it and/or modify
dnl it under the terms of the GNU General Public License as published by
dnl the Free Software Foundation; either version 2 of the License, or
dnl (at your option) any later version.
dnl 
dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl 
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software 
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
dnl 
dnl As a special exception to the GNU General Public License, if you 
dnl distribute this file as part of a program that contains a configuration 
dnl script generated by Autoconf, you may include it under the same 
dnl distribution terms that you use for the rest of that program.

AC_DEFUN(LF_USE_TEXIDOC,[
  dnl Check for the following utilities, needed by texidoc makefiles
  AC_PATH_PROGS(PERL, perl perl5, nope)
  AC_PATH_PROGS(TEX,  tex, nope)
  AC_PATH_PROGS(TEXI2DVI, texi2dvi, nope)
  AC_PATH_PROGS(DVIPS, dvips, nope)

  dnl Verify that all the needed programs are here, otherwise issue warnings
  if test "$PERL" = nope 
  then
    AC_MSG_WARN([missing perl. Need perl to build documentation.])
  fi
  if test "$TEX" = nope
  then
    AC_MSG_WARN([missing tex. Need tex to build documentation.])
  fi
  if test "$TEXI2DVI" = nope
  then
    AC_MSG_WARN([missing texi2dvi. Need texi2dvi to build documentation.])
  fi
  if test "$DVIPS" = nope
  then
    AC_MSG_WARN([missing dvips. Need dvips to build documentation.])
  fi
   
  dnl Export the pathnames to Automake
  AC_SUBST(PERL)
  AC_SUBST(TEXI2DVI) 
  AC_SUBST(DVIPS)
])
